﻿using System.Diagnostics;
using System.Windows.Input;

namespace CommandsSample
{
    class MainViewModel : NotifyPropertyChangedBase
    {
        static MainViewModel instance;

        public static MainViewModel Instance
        {
            get { return instance ?? (instance = new MainViewModel()); }
        }

        public ICommand ButtonCommand { get; private set; }

        public ICommand CommandGroup { get; private set; }

        private MainViewModel()
        {
            ButtonCommand = new RelayCommand(ButtonClicked, CanClickButton);
            var commandGroup = new CommandGroup();
            commandGroup.Commands.Add(ButtonCommand);
            commandGroup.Commands.Add(ApplicationCommands.Copy);
            commandGroup.Commands.Add(Commands.CustomRoutedCommand);
            CommandGroup = commandGroup;
        }

        private bool CanClickButton()
        {
            return true;
        }

        private void ButtonClicked()
        {
            Debug.Print("Relay command executed!");
        }
    }
}
