﻿Class MainViewModel : Inherits NotifyPropertyChangedBase
    Private Shared _instance As MainViewModel

    Public Shared ReadOnly Property Instance As MainViewModel
        Get
            If (_instance Is Nothing) Then _instance = New MainViewModel()
            Return _instance
        End Get
    End Property

    Private _buttonCommand As ICommand
    Private _commandGroup As ICommand

    Public Property ButtonCommand As ICommand
        Get
            Return _buttonCommand
        End Get
        Private Set(value As ICommand)
            _buttonCommand = value
        End Set
    End Property

    Public Property CommandGroup As ICommand
        Get
            Return _commandGroup
        End Get
        Private Set(value As ICommand)
            _commandGroup = value
        End Set
    End Property

    Private Sub New()
        ButtonCommand = New RelayCommand(AddressOf ButtonClicked, AddressOf CanClickButton)
        Dim commandGroup = New CommandGroup()
        commandGroup.Commands.Add(ButtonCommand)
        commandGroup.Commands.Add(ApplicationCommands.Copy)
        commandGroup.Commands.Add(Commands.CustomRoutedCommand)
        Me.CommandGroup = commandGroup
    End Sub

    Private Function CanClickButton() As Boolean
        Return True
    End Function

    Private Sub ButtonClicked()
        Debug.Print("Relay command executed!")
    End Sub
End Class
